//
//	
//	Widgets
/*

Copyright 2005/2006, Travel Widgets

*/



/*********************
 *	Main Functions   *
 *********************/


// returns a div
function getDiv(inner, css) {
	var div = document.createElement("div");
	div.setAttribute("class", css ? css : '');
	
	if(inner) {
		var div_inner = ('string' == typeof(inner)) ? document.createTextNode(inner) : inner;
		div.appendChild(div_inner);
	}
	
	return div;
}


function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	// done-button needs black font instead of white if stylesheet is 3
	var element = document.getElementById("done").firstChild.nextSibling;
	var oldstyle = element.getAttribute("style");
	if(stylesheet == 3)
		element.setAttribute("style", oldstyle + "; color:#000;");
	else
		element.setAttribute("style", oldstyle + "; color:#FFF;");
	
	adjustPrefs();
	
	if(window.widget)
		widget.prepareForTransition("ToBack");
				
	front.style.display = "none";
	back.style.display = "block";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);  
}

function switchPrefTab(tab) {
	var found = false;
	var thedivs = new Array("refresh", "mail", "ping", "style", "car");
	
	for(var i = 0; i < thedivs.length; i++) {
		if(thedivs[i] == tab) {
			document.getElementById("tab_" + thedivs[i]).setAttribute("class", "tabitem selected");
			document.getElementById("prefsection_" + thedivs[i]).style.display = "block";
			found = true;
		}
		else {
			document.getElementById("tab_" + thedivs[i]).setAttribute("class", "tabitem");
			document.getElementById("prefsection_" + thedivs[i]).style.display = "none";
		}
	}
	
	if(!found) {
		document.getElementById("prefsection_ping").style.display = "block";
	}
}

function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	setStylesheet(stylesheet);
	document.getElementById('refreshbutton').src = "Images_" + stylesheet + "/refresh.png";	// set refreshbutton matching stylesheet
	
	seconds = getTimer();
	refreshMode = getRefreshMode();
	refreshOnShow = getRefreshOnShow();
	doCountdown = (refreshMode == 'manual') ? 0 : 1;
	
	if(window.widget)
		widget.prepareForTransition("ToFront");
				
	front.style.display = "block";
	back.style.display = "none";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
	
	setTimeout("refreshState()", 100);
}




/*
 *************
 * Utilities *
 *************
 */




//	Localization
/*
function getLocalizedString (key)
{
	try {
		return localizedStrings[key];
	} catch (ex) {}

	return key;
}
*/






/*
 **********
 * Events *
 **********
 */

if(window.widget) {
	widget.onshow = onShow;
	widget.onhide = onHide;
}




/*
 ********************
 * GUI manipulation *
 ********************
 */


function blendFromTo(from_id, to_id) {
	var from = document.getElementById(from_id);
	var to = document.getElementById(to_id);
	
	if(from && to) {
		from.style.display = 'none';
		to.style.display = 'block';
	}
}





/*
 **************
 *  by Apple  *
 **************
 */

var flipShown = false;
var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function mousemove(event) {
	if(!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit(event) {
	if(flipShown) {
		
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}


// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)

function enterflip(event) {
	document.getElementById("fliprollie").style.display = "block";
}

function exitflip(event) {
	document.getElementById("fliprollie").style.display = "none";
}




